#include <cstdio>
#include <iostream>
#include <filesystem>
#include <string_view>
#include <fstream>
#include <format>
namespace fs = std::filesystem;

std::string get_projectname(){
    auto workdir = fs::canonical(fs::current_path());
    while(true){
        for(auto& entry : fs::directory_iterator(workdir)){
            if(entry.path().filename() == "xmake.lua"){
                auto file = std::ifstream(entry.path(), std::ios::in);
                std::string line;
                while(getline(file, line)){
                    if(line.find("target") != std::string::npos){
                        return line.substr(line.find("\"") + 1, line.find_last_of("\"") - line.find_first_of("\"") -1);
                    }
                }
            }
        }    
        if(workdir == fs::path("/home")){
            return "";
        }
        workdir = workdir.parent_path();
    }
}

int main(int argc, char** const argv){
    auto res = std::system("xmake build");
	if(argc < 2){
		if(res != 0) return -1;
		return std::system("xmake run");
	}
    auto project_name = get_projectname();
    if(project_name == ""){
        std::cout << "[Error] Not Find Xmake Project File" << std::endl;
        return -1;
    }
    std::string opt;
    for(int i = 1; i<argc;i++){
        opt += argv[i];
        opt += " ";
    }
    std::string really_cmd;
    std::format_to(std::back_inserter(really_cmd), "xmake run -w {} {} {}", fs::current_path().string(), project_name, opt);
	return std::system(really_cmd.c_str());
}
